package project1;

import java.awt.Button;
import java.awt.Checkbox;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.JFileChooser;

import jv.object.PsDebug;
import jv.object.PsPanel;
import jv.object.PsUpdateIf;
import jv.project.PjProject_IP;

public class PjProject1_IP extends PjProject_IP implements ActionListener, ItemListener {
	private static final long serialVersionUID = 1L;

	protected PjProject1 m_pjProject1;

	/* Controls Show */
	protected Checkbox m_setVisibible;
	protected Checkbox m_showVertices;
	protected Checkbox m_showEdges;
	protected Checkbox m_showFaces;
	protected Button m_reset;

	/* Controls PointSet */
	protected Button m_generateNeighborhood;
	protected Button m_generateNormals;

	/* Controls PolygonSet */
	protected Button m_generatePolygonSet;
	protected Button m_generateTubes;
	
	/* Controls PolygonSet */
	protected Button m_subdivide;
	protected Button m_simplify;
	protected Button m_identifyNeighbors;
	protected Button m_simplifyNeighbors;
	
	protected Button m_button;

	/* Modified loader with browse and load buttons, textfield and file chooser */
	protected Button m_loadBrowse;
	protected TextField m_loadTextField;
	protected JFileChooser m_loadFileChooser;
	protected Button m_loadButton;

	public PjProject1_IP() {
		super();
		m_generateNeighborhood = new Button(" Point Set Denoising");
		m_generateNeighborhood.addActionListener(this);

		if (getClass() == PjProject1_IP.class) {
			init();
		}
	}

	public void init() {
		super.init();
	}

	public void setParent(PsUpdateIf parent) {
		super.setParent(parent);
		m_pjProject1 = (PjProject1) m_project;
		setTitle("Template");

		/*
		 * Font setup
		 */
		Font f = new Font(null, 1, 14);

		/*
		 * Loader Panel
		 */
		PsPanel loadPanel = new PsPanel(new GridLayout(4, 1));
		Label loadLabel = new Label("Loader");
		loadLabel.setFont(f);
		loadLabel.setAlignment(Label.CENTER);
		loadPanel.add(loadLabel);
		m_loadTextField = new TextField(m_pjProject1.m_fileName);
		m_loadTextField.addActionListener(this);
		loadPanel.add(m_loadTextField);
		PsPanel loadButtonPanel = new PsPanel(new GridLayout(1, 2));
		m_loadButton = new Button("Load");
		m_loadButton.addActionListener(this);
		loadButtonPanel.add(m_loadButton);
		m_loadBrowse = new Button("Browse");
		m_loadBrowse.addActionListener(this);
		loadButtonPanel.add(m_loadBrowse);
		m_loadFileChooser = new JFileChooser();
		loadPanel.add(loadButtonPanel);
		add(loadPanel);

		/*
		 * Visuals
		 */
		PsPanel visualPanel = new PsPanel(new GridLayout(4, 1));
		Label visualLabel = new Label("Show");
		visualLabel.setFont(f);
		visualLabel.setAlignment(Label.CENTER);
		visualPanel.add(visualLabel);
		PsPanel visualSubPanel = new PsPanel(new GridLayout(1, 5));
		m_setVisibible = new Checkbox("Geometry");
		m_setVisibible.addItemListener(this);
		m_setVisibible.setState(true);
		visualSubPanel.add(m_setVisibible);
		m_showVertices = new Checkbox("Vertices");
		m_showVertices.addItemListener(this);
		m_showVertices.setState(false);
		visualSubPanel.add(m_showVertices);
		m_showEdges = new Checkbox("Edges");
		m_showEdges.addItemListener(this);
		m_showEdges.setState(false);
		visualSubPanel.add(m_showEdges);
		m_showFaces = new Checkbox("Faces");
		m_showFaces.addItemListener(this);
		m_showFaces.setState(true);
		visualSubPanel.add(m_showFaces);
		visualPanel.add(visualSubPanel);
		m_reset = new Button("Reset");
		m_reset.addActionListener(this);
		visualPanel.add(m_reset);
		add(visualPanel);

		/*
		 * PointSet Panel
		 */
		PsPanel pointSetPanel = new PsPanel(new GridLayout(4, 1));
		Label pointSetLabel = new Label("PgPointSet");
		pointSetLabel.setFont(f);
		pointSetLabel.setAlignment(Label.CENTER);
		pointSetPanel.add(pointSetLabel);
		pointSetPanel.add(m_pjProject1.m_radius.getInfoPanel());
		PsPanel pointSetSubPanel = new PsPanel(new GridLayout(1, 2));
		m_generateNeighborhood = new Button("Generate Neighborhood");
		m_generateNeighborhood.addActionListener(this);
		pointSetSubPanel.add(m_generateNeighborhood);
		m_generateNormals = new Button("Generate Normals");
		m_generateNormals.addActionListener(this);
		pointSetSubPanel.add(m_generateNormals);
		pointSetPanel.add(pointSetSubPanel);
		add(pointSetPanel);

		/*
		 * PolygonSet Panel
		 */
		PsPanel polygonSetPanel = new PsPanel(new GridLayout(4, 1));
		Label polygonSetLabel = new Label("PgPolygonSet");
		polygonSetLabel.setFont(f);
		polygonSetLabel.setAlignment(Label.CENTER);
		polygonSetPanel.add(polygonSetLabel);
		PsPanel polygonSetSubPanel = new PsPanel(new GridLayout(1, 2));
		m_generatePolygonSet = new Button("Generate PolygonSet");
		m_generatePolygonSet.addActionListener(this);
		polygonSetSubPanel.add(m_generatePolygonSet);
		m_generateTubes = new Button("Generate Tubes");
		m_generateTubes.addActionListener(this);
		polygonSetSubPanel.add(m_generateTubes);
		polygonSetPanel.add(polygonSetSubPanel);
		polygonSetPanel.add(m_pjProject1.m_refinementScale.getInfoPanel());
		add(polygonSetPanel);

		/*
		 * ElementSet Panel
		 */
		PsPanel elementSetPanel = new PsPanel(new GridLayout(4, 1));
		Label elementSetLabel = new Label("PgElementSet");
		elementSetLabel.setFont(f);
		elementSetLabel.setAlignment(Label.CENTER);
		elementSetPanel.add(elementSetLabel);
		PsPanel elementSetSubPanel = new PsPanel(new GridLayout(2,2));
		m_simplify = new Button("Simplify");
		m_simplify.addActionListener(this);
		elementSetSubPanel.add(m_simplify);
		m_subdivide = new Button("Subdivide");
		m_subdivide.addActionListener(this);
		elementSetSubPanel.add(m_subdivide);
		m_identifyNeighbors = new Button("Identify Neighbors");
		m_identifyNeighbors.addActionListener(this);
		elementSetSubPanel.add(m_identifyNeighbors);
		m_simplifyNeighbors = new Button("Simplify Neighbors");
		m_simplifyNeighbors.addActionListener(this);
		elementSetSubPanel.add(m_simplifyNeighbors);
		elementSetPanel.add(elementSetSubPanel);
		add(elementSetPanel);
		
		/*
		 * Misc
		 */
		m_button = new Button("Method");
		m_button.addActionListener(this);
//		add(m_button);
		
	}

	/**
	 * Here we arrive from outside world of this panel, e.g. if project has changed
	 * somewhere else and must update its panel. Such an update is automatically by
	 * superclasses of PjProject.
	 */
	public boolean update(Object event) {
		if (m_pjProject1 == null) {
			if (PsDebug.WARNING)
				PsDebug.warning("missing parent, setParent not called");
			return false;
		}
		return super.update(event);
	}

	public void actionPerformed(ActionEvent e) {
		Object source = e.getSource();
		if (source == m_reset) 
			m_pjProject1.resetGeometry();
		if (source == m_generateNeighborhood) 
			m_pjProject1.pointSet_Neighborhood();
		if (source == m_generateNormals) 
			m_pjProject1.pointSet_NormalEstimation();
		if (source == m_generatePolygonSet) 
			m_pjProject1.polygonSet_generate();
		if (source == m_generateTubes) 
			m_pjProject1.polygonSet_Tubes();
		if (source == m_simplify)
			m_pjProject1.elementSet_SimplificationSubdivision(0);
		if (source == m_subdivide)
			m_pjProject1.elementSet_SimplificationSubdivision(1);
		if (source == m_identifyNeighbors)
			m_pjProject1.elementSet_identifyNeighbors();
		if (source == m_simplifyNeighbors)
			m_pjProject1.elementSet_simplifyNeighbors();
		if (source == m_button)
			m_pjProject1.method();
		if (source == m_loadBrowse) {
			int returnVal = m_loadFileChooser.showOpenDialog(this);
			if (returnVal == JFileChooser.APPROVE_OPTION) {
				String filepath = m_loadFileChooser.getSelectedFile().getPath();
				m_pjProject1.load(filepath);
				m_loadTextField.setText(m_loadFileChooser.getSelectedFile().getPath());
			}
		}
		if (source == m_loadButton) 
			m_pjProject1.load(m_loadTextField.getText());
		if (source == m_loadTextField)
			m_pjProject1.load(m_loadTextField.getText());
	}

	@Override
	public void itemStateChanged(ItemEvent e) {
		Object source = e.getSource();
		if (source == m_setVisibible)
			m_pjProject1.setVisibility(0, m_setVisibible.getState());
		if (source == m_showVertices)
			m_pjProject1.setVisibility(1, m_showVertices.getState());
		if (source == m_showEdges)
			m_pjProject1.setVisibility(2, m_showEdges.getState());
		if (source == m_showFaces)
			m_pjProject1.setVisibility(3, m_showFaces.getState());
	}
}
