package template;

import java.awt.Button;
import java.awt.Color;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFileChooser;

import jv.object.PsDebug;
import jv.object.PsPanel;
import jv.object.PsUpdateIf;
import jv.project.PjProject_IP;

public class PjTemplate_IP extends PjProject_IP implements ActionListener {
	private static final long serialVersionUID = 1L;

	protected PjTemplate		m_pjTemplate;

	/* Controls */
	protected Button m_coreMethod;

	/* Modified loader with browse and load buttons, textfield and file chooser */
	protected Button			m_loadBrowse;
	protected TextField		m_loadTextField;
	protected JFileChooser	m_loadFileChooser;
	protected Button			m_loadButton;

	public PjTemplate_IP() {
		super();
		m_coreMethod = new Button(" Point Set Denoising");
		m_coreMethod.addActionListener(this);

		if (getClass() == PjTemplate_IP.class) {
			init();
		}
	}

	public void init() {
		super.init();
	}

	public void setParent(PsUpdateIf parent) {
		super.setParent(parent);
		m_pjTemplate = (PjTemplate)m_project;
		setTitle("Template");
		
		/* Font setup */
		Font f = new Font(null, 1, 14);

		/* Loader Panel */
		PsPanel loadPanel = new PsPanel(new GridLayout(4, 1));
		Label loadLabel = new Label("Loader");
		loadLabel.setFont(f);
		loadLabel.setAlignment(Label.CENTER);
		loadPanel.add(loadLabel);
		m_loadTextField = new TextField(m_pjTemplate.m_fileName);
		m_loadTextField.addActionListener(this);
		loadPanel.add(m_loadTextField);
		PsPanel loadButtonPanel = new PsPanel(new GridLayout(1, 2));
		m_loadButton = new Button("Load");
		m_loadButton.addActionListener(this);
		loadButtonPanel.add(m_loadButton);
		m_loadBrowse = new Button("Browse");
		m_loadBrowse.addActionListener(this);
		loadButtonPanel.add(m_loadBrowse);
		m_loadFileChooser = new JFileChooser();
		loadPanel.add(loadButtonPanel);
		add(loadPanel);
		
		/* Parameter Panel */
		PsPanel parameterPanel = new PsPanel(new GridLayout(3,1));
		Label parameterLabel = new Label("Parameter");
		parameterLabel.setFont(f);
		parameterLabel.setAlignment(Label.CENTER);
		parameterPanel.add(parameterLabel);
		parameterPanel.add(m_pjTemplate.m_intSlider.getInfoPanel());
		add(parameterPanel);
		
		/* Control Panel */
		PsPanel controlPanel = new PsPanel(new GridLayout(3,1));
		Label controlLabel = new Label("Controls");
		controlLabel.setFont(f);
		controlLabel.setAlignment(Label.CENTER);
		controlPanel.add(controlLabel);
		m_coreMethod = new Button("Method");
		m_coreMethod.addActionListener(this);
		controlPanel.add(m_coreMethod);
		add(controlPanel);
	}

	/**
	 * Here we arrive from outside world of this panel, e.g. if
	 * project has changed somewhere else and must update its panel. Such an update
	 * is automatically by superclasses of PjProject.
	 */
	public boolean update(Object event) {
		if (m_pjTemplate == null) {
			if (PsDebug.WARNING) PsDebug.warning("missing parent, setParent not called");
			return false;
		}
		return super.update(event);
	}

	public void actionPerformed(ActionEvent e) {
		Object source = e.getSource();
		if (source == m_coreMethod) {
			m_coreMethod.setBackground(new Color(55, 115, 135));
			m_pjTemplate.method();
			m_coreMethod.setBackground(new Color(225, 225, 225));
		}
		if (source == m_loadBrowse) {
			int returnVal = m_loadFileChooser.showOpenDialog(this);
			if (returnVal == JFileChooser.APPROVE_OPTION) {
				String filepath = m_loadFileChooser.getSelectedFile().getPath();
				m_pjTemplate.load(filepath);
				m_loadTextField.setText(m_loadFileChooser.getSelectedFile().getPath());
			}
		}
		if (source == m_loadButton) {
			m_pjTemplate.load(m_loadTextField.getText());
		}
		if (source == m_loadTextField) {
			m_pjTemplate.load(m_loadTextField.getText());
		}
	}
}
